<?php

/**
 *  Sandbox Authorize
dediteam69 / Ded1@gency

API LOGIN ID : 2PnJWh4S9D6k
TRANSACTION KEY : 5H49H8PB8rB68wyc
SECRET KEY : Simon
 */

namespace Bydedi\Payment;

use net\authorize\api\contract\v1 as AnetAPI;
use net\authorize\api\controller as AnetController;
use net\authorize\api\constants\ANetEnvironment;

/**
 * Class AuthorizeDirect
 * @package Shopbydedi\Payment
 */
class AuthorizeDirect
{
    /**
     * @var AnetAPI\MerchantAuthenticationType
     */
    protected $merchantAuthentication;

    /**
     * @var string
     */
    protected $mode;

    /**
     * @var string
     */
    protected $classNameTpe;

    /**
     * @var string
     */
    protected $functionTpeOk;

    /**
     * @var string
     */
    protected $functionTpeKo;

    public function __construct($config)
    {
        if ($config['authorize']['mode'] != 'prod') {
            $config['authorize']['name'] = '2PnJWh4S9D6k';
            $config['authorize']['transaction_key'] = '5H49H8PB8rB68wyc';
        }

        $this->merchantAuthentication = new AnetAPI\MerchantAuthenticationType();
        $this->merchantAuthentication->setName($config['authorize']['name']);
        $this->merchantAuthentication->setTransactionKey($config['authorize']['transaction_key']);

        $this->mode = ($config['authorize']['mode'] == 'prod') ? ANetEnvironment::PRODUCTION : ANetEnvironment::SANDBOX;

        $this->classNameTpe = $config['authorize']['classNameTpe'];
        $this->functionTpeOk = $config['authorize']['functionTpeOk'];
        $this->functionTpeKo = $config['authorize']['functionTpeKo'];

    }

    /**
     * @param $tpe_id
     * @param $amount
     * @param $cardNumber
     * @param $cardExpirationDate
     * @param $cardCrypto
     * @param $customer
     * @param $shipTo
     * @param $buildTo
     *
     * @return mixed
     */
    public function doAuthorization($tpe_id, $amount, $cardNumber, $cardExpirationDate, $cardCrypto= '',$customer = '',$shipTo = '', $buildTo = '', $taxAmout = '',$shipAmount = '')
    {
        $creditCard = new AnetAPI\CreditCardType();
        $creditCard->setCardNumber($cardNumber);                    // "4111111111111111"
        $creditCard->setExpirationDate($cardExpirationDate);        // "2038-12"
        if(!empty($cardCrypto)) {
            $creditCard->setCardCode($cardCrypto);
        }
        $paymentOne = new AnetAPI\PaymentType();
        $paymentOne->setCreditCard($creditCard);

        // Create a transaction

        $transactionRequestType = new AnetAPI\TransactionRequestType();
        $transactionRequestType->setTransactionType("authOnlyTransaction");
        $transactionRequestType->setAmount($amount);
        $transactionRequestType->setPayment($paymentOne);
        if(!empty($customer)) {
            $transactionRequestType->setCustomer($customer);
        }
        if(!empty($shipTo)) {
            $transactionRequestType->setShipTo($shipTo);
        }
        if(!empty($buildTo)) {
            $transactionRequestType->setBillTo($buildTo);
        }

        if(!empty($taxAmout)) {
            $transactionRequestType->setTax($taxAmout);
        }
        if(!empty($shipAmount)) {
            $transactionRequestType->setShipping($shipAmount);
        }

        $request = new AnetAPI\CreateTransactionRequest();
        $request->setMerchantAuthentication($this->merchantAuthentication);
        $request->setTransactionRequest($transactionRequestType);
        $request->setRefId($tpe_id);
        $controller = new AnetController\CreateTransactionController($request);

        /** @var \net\authorize\api\contract\v1\CreateTransactionResponse $responseAuthorize */
        $responseAuthorize = $controller->executeWithApiResponse($this->mode);

        $response['authorize'] = $responseAuthorize;
        $response['order_id'] = $tpe_id;

        return $this->response($response);
    }

    /**
     * @param $tpe_id
     * @param $amount
     * @param $cardNumber
     * @param $cardExpirationDate
     * @param $cardCrypto
     * @param $customer
     * @param $shipTo
     * @param $buildTo
     *
     * @return mixed
     */
    public function doDebit($tpe_id, $amount, $cardNumber, $cardExpirationDate, $cardCrypto= '',$customer = '',$shipTo = '', $buildTo = '')
    {
        $creditCard = new AnetAPI\CreditCardType();
        $creditCard->setCardNumber($cardNumber);                    // "4111111111111111"
        $creditCard->setExpirationDate($cardExpirationDate);        // "2038-12"
        if(!empty($cardCrypto)) {
            $creditCard->setCardCode($cardCrypto);
        }
        $paymentOne = new AnetAPI\PaymentType();
        $paymentOne->setCreditCard($creditCard);

        // Create a transaction
        $transactionRequestType = new AnetAPI\TransactionRequestType();
        $transactionRequestType->setTransactionType("authCaptureTransaction");
        $transactionRequestType->setAmount($amount);
        $transactionRequestType->setPayment($paymentOne);
        if(!empty($customer)) {
            $transactionRequestType->setCustomer($customer);
        }
        if(!empty($shipTo)) {
            $transactionRequestType->setShipTo($shipTo);
        }
        if(!empty($buildTo)) {
            $transactionRequestType->setBillTo($buildTo);
        }

        $request = new AnetAPI\CreateTransactionRequest();
        $request->setMerchantAuthentication($this->merchantAuthentication);
        $request->setTransactionRequest($transactionRequestType);
        $controller = new AnetController\CreateTransactionController($request);

        /** @var \net\authorize\api\contract\v1\CreateTransactionResponse $responseAuthorize */
        $responseAuthorize = $controller->executeWithApiResponse($this->mode);

        $response['authorize'] = $responseAuthorize;
        $response['order_id'] = $tpe_id;

        return $this->response($response);

    }

    /**
     * @param array $request
     *
     * @return mixed
     */
    public function response($request)
    {

        $return = ['status' => false];

        if (!empty($request['order_id'])) {
            $tpe = new $this->classNameTpe;

            if ($request['authorize'] != null) {
                /** @var \net\authorize\api\contract\v1\TransactionResponseType $tresponse */
                $tresponse = $request['authorize']->getTransactionResponse();

                $messages = $tresponse->getMessages();
                $request['messages'] = '';

                // cas response ok
                if (($tresponse != null) && ($tresponse->getResponseCode() == "1")) {

                    $request['commande_authorize_id'] = $tresponse->getTransId();
                    $request['code'] = $tresponse->getResponseCode();
                    //paiement OK
                    call_user_func_array(array($tpe, $this->functionTpeOk), array($request['order_id'], $request));

                    foreach ($messages as $message) {
                        $request['messages'] .= sprintf('%s - %s', $message->getCode(), $message->getDescription());
                    }

                    $return['status'] = true;
                    $return['tpe_reference_id'] = $request['order_id'];
                } else {
                    $request['error'] = "Charge Credit Card ERROR :  Invalid response";
                    $request['error_plus'] = '';

                    $errors = $tresponse->getErrors();

                    foreach ($messages as $message) {
                        $request['messages'] .= sprintf('%s - %s', $message->getCode(), $message->getText());
                    }

                    foreach ($errors as $error) {
                        $request['error_plus'] .= sprintf('%s - %s', $error->getErrorCode(), $error->getErrorText());
                    }

                    $return = array_merge($request, $request);

                    //paiement KO
                    call_user_func_array(array($tpe, $this->functionTpeKo), array($request['order_id'], $request));
                }
            } else {
                $request['error'] = "Charge Credit card Null response returned";

                $return = array_merge($request, $request);
            }

            unset($request['authorize']);
        }

        return $return;
    }

    /**
     * @param $params
     * @return mixed
     */
    public function sendRequest($params)
    {
        // TODO: Implement sendRequest() method.
    }


    /**
     * @param $authorize_id
     * @param $amount
     * @param $tpe_id
     *
     * @return mixed
     */
    public function doCapture($authorize_id,$amount,$tpe_id,$commande_id = "")
    {

        $transactionRequestType = new AnetAPI\TransactionRequestType();
        $transactionRequestType->setTransactionType("priorAuthCaptureTransaction");
        $transactionRequestType->setRefTransId($authorize_id);
        $transactionRequestType->setAmount($amount);

        if(!empty($commande_id)) {
            $order = new AnetAPI\OrderType();
            $order->setInvoiceNumber($commande_id);
            $order->setDescription('Commande Dedi '.$commande_id);
            $transactionRequestType->setOrder($order);
        }

        $request = new AnetAPI\CreateTransactionRequest();
        $request->setMerchantAuthentication($this->merchantAuthentication);
        $request->setTransactionRequest($transactionRequestType);
        $request->setRefId($tpe_id);

        $controller = new AnetController\CreateTransactionController($request);
        /** @var \net\authorize\api\contract\v1\CreateTransactionResponse $responseAuthorize */
        $responseAuthorize = $controller->executeWithApiResponse($this->mode);

        return $responseAuthorize;
    }


    function getCustomerProfile($email)
    {
        // Retrieve an existing customer profile along with all the associated payment profiles and shipping addresses
        $request = new AnetAPI\GetCustomerProfileRequest();
        $request->setMerchantAuthentication($this->merchantAuthentication);
        $request->setEmail($email);
        $controller = new AnetController\GetCustomerProfileController($request);
        $response = $controller->executeWithApiResponse( $this->mode);

        if (($response != null) && ($response->getMessages()->getResultCode() == "Ok") )
        {
            $profileSelected = $response->getProfile();

            if(!empty($profileSelected->getCustomerProfileId()))
            {
                return $profileSelected->getCustomerProfileId();
            }
        }
        else
        {
            return false;
        }
        return false;
    }


    function createCustomerProfile($cardNumber,$cardExpirationDate,$cardCrypto,$client_id,$email,$billTo,$customerShippingAddress,$refId)
    {


        // Set the transaction's refId


        // Create a Customer Profile Request
        //  1. (Optionally) create a Payment Profile
        //  2. (Optionally) create a Shipping Profile
        //  3. Create a Customer Profile (or specify an existing profile)
        //  4. Submit a CreateCustomerProfile Request
        //  5. Validate Profile ID returned

        // Set credit card information for payment profile
        $creditCard = new AnetAPI\CreditCardType();
        $creditCard->setCardNumber($cardNumber);                    // "4111111111111111"
        $creditCard->setExpirationDate($cardExpirationDate);        // "2038-12"
        if(!empty($cardCrypto)) {
            $creditCard->setCardCode($cardCrypto);
        }
        $paymentCreditCard = new AnetAPI\PaymentType();
        $paymentCreditCard->setCreditCard($creditCard);

        // Create an array of any shipping addresses
        $shippingProfiles[] = $customerShippingAddress;


        // Create a new CustomerPaymentProfile object
        $paymentProfile = new AnetAPI\CustomerPaymentProfileType();
        $paymentProfile->setCustomerType('individual');
        $paymentProfile->setBillTo($billTo);
        $paymentProfile->setPayment($paymentCreditCard);
        $paymentProfile->setDefaultpaymentProfile(true);
        $paymentProfiles[] = $paymentProfile;


        // Create a new CustomerProfileType and add the payment profile object
        $customerProfile = new AnetAPI\CustomerProfileType();
        $customerProfile->setDescription("Customer");
        $customerProfile->setMerchantCustomerId($client_id);
        $customerProfile->setEmail($email);
        $customerProfile->setpaymentProfiles($paymentProfiles);
        $customerProfile->setShipToList($shippingProfiles);


        // Assemble the complete transaction request
        $request = new AnetAPI\CreateCustomerProfileRequest();
        $request->setMerchantAuthentication($this->merchantAuthentication);
        $request->setRefId($refId);
        $request->setProfile($customerProfile);

        // Create the controller and get the response
        $controller = new AnetController\CreateCustomerProfileController($request);
        $response = $controller->executeWithApiResponse($this->mode);

        if (($response != null) && ($response->getMessages()->getResultCode() == "Ok")) {
            return $paymentProfiles[0];
        } else {
            return false;
        }
    }

    function createCustomerPaymentProfile($cardNumber,$cardExpirationDate,$cardCrypto,$existingcustomerprofileid,$billTo)
    {


        // Set the transaction's refId


        // Create a Customer Profile Request
        //  1. (Optionally) create a Payment Profile
        //  2. (Optionally) create a Shipping Profile
        //  3. Create a Customer Profile (or specify an existing profile)
        //  4. Submit a CreateCustomerProfile Request
        //  5. Validate Profile ID returned

        // Set credit card information for payment profile
        $creditCard = new AnetAPI\CreditCardType();
        $creditCard->setCardNumber($cardNumber);                    // "4111111111111111"
        $creditCard->setExpirationDate($cardExpirationDate);        // "2038-12"
        if(!empty($cardCrypto)) {
            $creditCard->setCardCode($cardCrypto);
        }
        $paymentCreditCard = new AnetAPI\PaymentType();
        $paymentCreditCard->setCreditCard($creditCard);

        // Create a new Customer Payment Profile object
        $paymentprofile = new AnetAPI\CustomerPaymentProfileType();
        $paymentprofile->setCustomerType('individual');
        $paymentprofile->setBillTo($billTo);
        $paymentprofile->setPayment($paymentCreditCard);
        $paymentprofile->setDefaultPaymentProfile(true);

        $paymentprofiles[] = $paymentprofile;

        // Assemble the complete transaction request
        $paymentprofilerequest = new AnetAPI\CreateCustomerPaymentProfileRequest();
        $paymentprofilerequest->setMerchantAuthentication($this->merchantAuthentication);

        // Add an existing profile id to the request
        $paymentprofilerequest->setCustomerProfileId($existingcustomerprofileid);
        $paymentprofilerequest->setPaymentProfile($paymentprofile);
        $paymentprofilerequest->setValidationMode("liveMode");

        // Create the controller and get the response
        $controller = new AnetController\CreateCustomerPaymentProfileController($paymentprofilerequest);
        $response = $controller->executeWithApiResponse($this->mode);

        if (($response != null) && ($response->getMessages()->getResultCode() == "Ok")) {
            return $response->getCustomerPaymentProfileId();
        } else {
            return false;
        }
    }

}
